#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "tine.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
int almInfoCheck(char *cnt, char *cmpstr, char *field, int sev, int sys);
int ReportError(int cc);

char *usageTxt[] = {
  "\nScans the alarm definintions for the given context and outputs those meeting the comparison criteria\n",
  "alminfocheck /c=<context> /<field><comparison><value> [/d=debug level]",
  "\n\t <field> can be 'severity' or 'system'"
  "\n\te.g. alminfocheck /c=TEST /severity^>=8",
  "\n\t (note the escape '^' character needed when > or < are used.)"
};

#define nUsageLines (int)(sizeof(usageTxt)/sizeof(char *))

int main(int argc, char *argv[])
{
  int i, len = 0, n = 0, sev = 0, sys = 0;
  char *c, *ctx = NULL, *fld = "severity", *cmp = NULL;
  char *tok = "!><=", *cp=NULL;
  char scratch[32], context[64];
  gListenForGlobals = gListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 200;
  nofeclog = TRUE;
  SetUserType("CMDLINE");
  printf("\n");
  ctx = argv[1];
  if (argc < 2)
  {
  dumpUsage:
    for (i = 0; i < nUsageLines; i++)
    {
      printf(i == 1 ? "Usage : " : "        ");
      printf("%s\n", usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  for (i = 1; i < argc; i++)
  { /* options given */
    c = argv[i];
    if (*c == '/') c++;
    switch (tolower(*c))
    {
      case 'c':
        if ((c=strchr(c, '=')) != NULL)
        {
          c++;
          strncpy(context, c, 32);
          ctx = context;
        }
        continue;
      case 's':
        if (!strncmp(c, "sy", 2))
        {
          sys = -1;
          fld = "system";
        }
        if ((cmp=strpbrk(c, tok)) != NULL)
        {
          for (c=cmp; strpbrk(c, tok) != NULL; c++);
          if (sys < 0)
            sys = atoi(c);
          else
            sev = atoi(c);
          *c = 0;
        }
        continue;
      case 'd':
        if ((c = strchr(c, '=')) != NULL)
        {
          c++;
          strncpy(scratch, c, 32);
          tineDebug = atoi(scratch);
          foregroundTTY = TRUE;
        }
        continue;
      case 'h':
      case '?':
        goto dumpUsage;
      default:
        continue;
    }
  }
  return ReportError(almInfoCheck(ctx,cmp,fld,sev,sys));
}
